/*
 * Copyright by Intland Software
 *
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Intland Software. ("Confidential Information"). You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Intland.
 */
package com.intland.codebeamer.wiki.plugins.base;

import org.apache.commons.lang.StringUtils;
import org.apache.commons.lang.builder.ReflectionToStringBuilder;

/**
 * Base POJO command bean for reuse in subclasses of AbstractCommandWikiPlugin.
 *
 * @author <a href="mailto:zoltan.luspai@intland.com">Zoltan Luspai</a>
 * $Id$
 */
public class BaseWikiPluginCommand {

	// optional title
	private String title = null;

	// default maximum number of elements listed in plugins
	public final static int DEFAULT_MAX_ELEMENTS = 20;

	// maximum number of elements to show by the plugin.
	private Integer max = new Integer(DEFAULT_MAX_ELEMENTS);

	// extra CSS class to add to the outermost element of the markup (typically a table)
	private String cssClass = null;
	// extra CSS style to add to the outermost element of the markup (typically a table)
	private String cssStyle = null;

	/**
	 * @return the title
	 */
	public final String getTitle() {
		return title;
	}
	/**
	 * @param title the title to set
	 */
	public void setTitle(String title) {
		this.title = StringUtils.trimToNull(title);
	}

	/**
	 * @return the max
	 */
	public final Integer getMax() {
		return max;
	}
	/**
	 * @param max the max to set
	 */
	public void setMax(Integer max) {
		this.max = max;
	}

	/**
	 * @return the cssClass
	 */
	public final String getCssClass() {
		return cssClass;
	}

	/**
	 * @param cssClass the cssClass to set
	 */
	public void setCssClass(String cssClass) {
		this.cssClass = cssClass;
	}

	/**
	 * @return the cssStyle
	 */
	public final String getCssStyle() {
		return cssStyle;
	}
	/**
	 * @param cssStyle the cssStyle to set
	 */
	public void setCssStyle(String cssStyle) {
		this.cssStyle = cssStyle;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	public String toString() {
		return ReflectionToStringBuilder.toString(this);
	}

}
