/*
 GoogleMaps Plugin

 Copyright (C) 2006 i3G Institut - Hochschule Heilbronn

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as published by
 the Free Software Foundation; either version 2.1 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package com.intland.codebeamer.wiki.plugins.googlemaps.tests;

import com.intland.codebeamer.wiki.CodeBeamerWikiContext;
import com.intland.codebeamer.wiki.plugins.googlemaps.Marker;
import com.intland.codebeamer.wiki.test.AbstractWikiTests;

/**
 *
 * @author Amir Farokhzad
 *
 */
public class MarkerTest extends AbstractWikiTests {

    public void testMarkers() {
    	CodeBeamerWikiContext context = createWikiContext();

        String lines = "Marker:100,50\nNew York";
        Marker marker = new Marker(lines, context);
        assertEquals(100.0, marker.getCoordinate().getLat(),
                GoogleMapsTest.DELTA);
        assertEquals(50.0, marker.getCoordinate().getLng(),
                GoogleMapsTest.DELTA);
        assertEquals("",marker.getName());
        assertEquals(1, marker.getTabs().length);
        assertEquals("", marker.getTabs()[0].getHeading());
        assertEquals("New York", marker.getTabs()[0].getBody());
        assertEquals("RED",marker.getIcon().toUpperCase());

        lines = "Green Marker P1:100,50";
        marker = new Marker(lines, context);
        assertEquals("GREEN",marker.getIcon().toUpperCase());
        assertEquals(100.0, marker.getCoordinate().getLat(),
                GoogleMapsTest.DELTA);
        assertEquals(50.0, marker.getCoordinate().getLng(),
                GoogleMapsTest.DELTA);
        assertEquals("P1",marker.getName());

        lines = "Marker P1:100,50\nTab: City\nNew York\n\nTab:Tab2\nTab body";
        marker = new Marker(lines, context);
        assertEquals("P1",marker.getName());
        assertEquals(100.0, marker.getCoordinate().getLat(),
                GoogleMapsTest.DELTA);
        assertEquals(50.0, marker.getCoordinate().getLng(),
                GoogleMapsTest.DELTA);
        assertEquals(2, marker.getTabs().length);
        assertEquals("City", marker.getTabs()[0].getHeading());
        assertEquals("New York", marker.getTabs()[0].getBody());
        assertEquals("Tab2", marker.getTabs()[1].getHeading());
        assertEquals("Tab body", marker.getTabs()[1].getBody());
    }

}
